"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantRepresentation(ProtocolElement):
    """
    A variant represented in a given assembly
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "assembly",
        "variant",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import opencb as opencb_1_3_0

        return {
            "variant": opencb_1_3_0.VariantAvro,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "assembly": reports_5_0_0.Assembly,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0
        from protocols.protocol_6_1 import opencb as opencb_1_3_0
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.Assembly": reports_5_0_0.Assembly,
            "org.opencb.biodata.models.variant.avro.VariantAvro": opencb_1_3_0.VariantAvro,
            "org.gel.models.cva.avro.VariantRepresentation": cva_1_0_0.VariantRepresentation,
        }

    __slots__ = [
        "assembly",
        "variant",
        "annotationsVersion",
        "annotatorVersion",
    ]

    def __init__(
        self,
        assembly,
        variant,
        annotationsVersion=None,
        annotatorVersion=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_0_0.VariantRepresentation model.

        :param assembly:
            The assembly on which this variant is represented
        :type assembly: Assembly
        :param variant:
            The variant
        :type variant: VariantAvro
        :param annotationsVersion:
            The annotator data version
        :type annotationsVersion: None | str
        :param annotatorVersion:
            The annotator software version
        :type annotatorVersion: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.0"
